import time

import rclpy
from rclpy.node import Node

from sensor_msgs.msg import Imu


class ZedTimestampNode(Node):

    def __init__(self):
        super().__init__('zed_munger_node')

        self.last_zed_imu_msg = None
        self.zed_imu_sub = self.create_subscription(Imu, '/zed/zed_node/imu/data', self.zed_imu_callback, 1)


    def zed_imu_callback(self, msg):
        #print(f"zed_imu_callback {msg}")
        #print(msg)
        #print(msg.header)
        #print(msg.header.stamp)
        header_timestamp = msg.header.stamp.sec + msg.header.stamp.nanosec * 1e-9
        receive_timestamp = time.time()
        print(f"timestamp delta @ {receive_timestamp:0.3f} {receive_timestamp - header_timestamp:.3f}")
        #self.last_zed_imu_msg = msg
        #msg.header.timestamp


def main(args=None):
    print("Init...")
    rclpy.init(args=args)
    node = ZedTimestampNode()

    print("Spin...")
    rclpy.spin(node)

    print("Shutdown...")
    node.destroy_node()
    rclpy.shutdown()

if __name__ == '__main__':
    main()
